~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-4.13.16)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0             << 
  3 #                                                   2 #
  4 # link vmlinux                                      3 # link vmlinux
  5 #                                                   4 #
  6 # vmlinux is linked from the objects in vmlinu !!   5 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  7 # vmlinux.a contains objects that are linked u !!   6 # $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.o files
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar !!   7 # from top-level directories in the kernel tree, others are specified in
  9 # (not within --whole-archive), and do not req !!   8 # arch/$(ARCH)/Makefile. Ordering when linking is important, and
                                                   >>   9 # $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
                                                   >>  10 # which are linked conditionally (not within --whole-archive), and do not
                                                   >>  11 # require symbol indexes added.
 10 #                                                  12 #
 11 # vmlinux                                          13 # vmlinux
 12 #   ^                                              14 #   ^
 13 #   |                                              15 #   |
 14 #   +--< vmlinux.a                             !!  16 #   +-< $(KBUILD_VMLINUX_INIT)
                                                   >>  17 #   |   +--< init/version.o + more
                                                   >>  18 #   |
                                                   >>  19 #   +--< $(KBUILD_VMLINUX_MAIN)
                                                   >>  20 #   |    +--< drivers/built-in.o mm/built-in.o + more
 15 #   |                                              21 #   |
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                    22 #   +--< $(KBUILD_VMLINUX_LIBS)
 17 #   |    +--< lib/lib.a + more                     23 #   |    +--< lib/lib.a + more
 18 #   |                                              24 #   |
 19 #   +-< ${kallsymso} (see description in KALLS     25 #   +-< ${kallsymso} (see description in KALLSYMS section)
 20 #                                                  26 #
 21 # vmlinux version (uname -v) cannot be updated     27 # vmlinux version (uname -v) cannot be updated during normal
 22 # descending-into-subdirs phase since we do no     28 # descending-into-subdirs phase since we do not yet know if we need to
 23 # update vmlinux.                                  29 # update vmlinux.
 24 # Therefore this step is delayed until just be     30 # Therefore this step is delayed until just before final link of vmlinux.
 25 #                                                  31 #
 26 # System.map is generated to document addresse     32 # System.map is generated to document addresses of all kernel symbols
 27                                                    33 
 28 # Error out on error                               34 # Error out on error
 29 set -e                                             35 set -e
 30                                                    36 
 31 LD="$1"                                        << 
 32 KBUILD_LDFLAGS="$2"                            << 
 33 LDFLAGS_vmlinux="$3"                           << 
 34                                                << 
 35 is_enabled() {                                 << 
 36         grep -q "^$1=y" include/config/auto.co << 
 37 }                                              << 
 38                                                << 
 39 # Nice output in kbuild format                     37 # Nice output in kbuild format
 40 # Will be supressed by "make -s"                   38 # Will be supressed by "make -s"
 41 info()                                             39 info()
 42 {                                                  40 {
 43         printf "  %-7s %s\n" "${1}" "${2}"     !!  41         if [ "${quiet}" != "silent_" ]; then
                                                   >>  42                 printf "  %-7s %s\n" ${1} ${2}
                                                   >>  43         fi
 44 }                                                  44 }
 45                                                    45 
 46 # Link of vmlinux                              !!  46 # Thin archive build here makes a final archive with symbol table and indexes
 47 # ${1} - output file                           !!  47 # from vmlinux objects INIT and MAIN, which can be used as input to linker.
 48 vmlinux_link()                                 !!  48 # KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
                                                   >>  49 # added.
                                                   >>  50 #
                                                   >>  51 # Traditional incremental style of link does not require this step
                                                   >>  52 #
                                                   >>  53 # built-in.o output file
                                                   >>  54 #
                                                   >>  55 archive_builtin()
 49 {                                                  56 {
 50         local output=${1}                      !!  57         if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 51         local objs                             !!  58                 info AR built-in.o
 52         local libs                             !!  59                 rm -f built-in.o;
 53         local ld                               !!  60                 ${AR} rcsTP${KBUILD_ARFLAGS} built-in.o                 \
 54         local ldflags                          !!  61                                         ${KBUILD_VMLINUX_INIT}          \
 55         local ldlibs                           !!  62                                         ${KBUILD_VMLINUX_MAIN}
 56                                                << 
 57         info LD ${output}                      << 
 58                                                << 
 59         # skip output file argument            << 
 60         shift                                  << 
 61                                                << 
 62         if is_enabled CONFIG_LTO_CLANG || is_e << 
 63                 # Use vmlinux.o instead of per << 
 64                 objs=vmlinux.o                 << 
 65                 libs=                          << 
 66         else                                   << 
 67                 objs=vmlinux.a                 << 
 68                 libs="${KBUILD_VMLINUX_LIBS}"  << 
 69         fi                                     << 
 70                                                << 
 71         if is_enabled CONFIG_MODULES; then     << 
 72                 objs="${objs} .vmlinux.export. << 
 73         fi                                         63         fi
                                                   >>  64 }
 74                                                    65 
 75         objs="${objs} init/version-timestamp.o !!  66 # Link of vmlinux.o used for section mismatch analysis
                                                   >>  67 # ${1} output file
                                                   >>  68 modpost_link()
                                                   >>  69 {
                                                   >>  70         local objects
 76                                                    71 
 77         if [ "${SRCARCH}" = "um" ]; then       !!  72         if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 78                 wl=-Wl,                        !!  73                 objects="--whole-archive                                \
 79                 ld="${CC}"                     !!  74                         built-in.o                                      \
 80                 ldflags="${CFLAGS_vmlinux}"    !!  75                         --no-whole-archive                              \
 81                 ldlibs="-lutil -lrt -lpthread" !!  76                         --start-group                                   \
                                                   >>  77                         ${KBUILD_VMLINUX_LIBS}                          \
                                                   >>  78                         --end-group"
 82         else                                       79         else
 83                 wl=                            !!  80                 objects="${KBUILD_VMLINUX_INIT}                         \
 84                 ld="${LD}"                     !!  81                         --start-group                                   \
 85                 ldflags="${KBUILD_LDFLAGS} ${L !!  82                         ${KBUILD_VMLINUX_MAIN}                          \
 86                 ldlibs=                        !!  83                         ${KBUILD_VMLINUX_LIBS}                          \
 87         fi                                     !!  84                         --end-group"
 88                                                << 
 89         ldflags="${ldflags} ${wl}--script=${ob << 
 90                                                << 
 91         # The kallsyms linking does not need d << 
 92         if [ -n "${strip_debug}" ] ; then      << 
 93                 ldflags="${ldflags} ${wl}--str << 
 94         fi                                     << 
 95                                                << 
 96         if is_enabled CONFIG_VMLINUX_MAP; then << 
 97                 ldflags="${ldflags} ${wl}-Map= << 
 98         fi                                         85         fi
 99                                                !!  86         ${LD} ${LDFLAGS} -r -o ${1} ${objects}
100         ${ld} ${ldflags} -o ${output}          << 
101                 ${wl}--whole-archive ${objs} $ << 
102                 ${wl}--start-group ${libs} ${w << 
103                 ${kallsymso} ${btf_vmlinux_bin << 
104 }                                                  87 }
105                                                    88 
106 # generate .BTF typeinfo from DWARF debuginfo  !!  89 # Link of vmlinux
107 # ${1} - vmlinux image                         !!  90 # ${1} - optional extra .o files
108 gen_btf()                                      !!  91 # ${2} - output file
                                                   >>  92 vmlinux_link()
109 {                                                  93 {
110         local pahole_ver                       !!  94         local lds="${objtree}/${KBUILD_LDS}"
111         local btf_data=${1}.btf.o              !!  95         local objects
                                                   >>  96 
                                                   >>  97         if [ "${SRCARCH}" != "um" ]; then
                                                   >>  98                 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
                                                   >>  99                         objects="--whole-archive                        \
                                                   >> 100                                 built-in.o                              \
                                                   >> 101                                 --no-whole-archive                      \
                                                   >> 102                                 --start-group                           \
                                                   >> 103                                 ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 104                                 --end-group                             \
                                                   >> 105                                 ${1}"
                                                   >> 106                 else
                                                   >> 107                         objects="${KBUILD_VMLINUX_INIT}                 \
                                                   >> 108                                 --start-group                           \
                                                   >> 109                                 ${KBUILD_VMLINUX_MAIN}                  \
                                                   >> 110                                 ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 111                                 --end-group                             \
                                                   >> 112                                 ${1}"
                                                   >> 113                 fi
112                                                   114 
113         if ! [ -x "$(command -v ${PAHOLE})" ]; !! 115                 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}             \
114                 echo >&2 "BTF: ${1}: pahole ($ !! 116                         -T ${lds} ${objects}
115                 return 1                       << 
116         fi                                     << 
117                                                << 
118         pahole_ver=$(${PAHOLE} --version | sed << 
119         if [ "${pahole_ver}" -lt "116" ]; then << 
120                 echo >&2 "BTF: ${1}: pahole ve << 
121                 return 1                       << 
122         fi                                     << 
123                                                << 
124         info BTF "${btf_data}"                 << 
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J << 
126                                                << 
127         # Create ${btf_data} which contains ju << 
128         # SHF_ALLOC because .BTF will be part  << 
129         # deletes all symbols including __star << 
130         # be redefined in the linker script. A << 
131         # objcopy warnings: "empty loadable se << 
132         ${OBJCOPY} --only-section=.BTF --set-s << 
133                 --strip-all ${1} "${btf_data}" << 
134         # Change e_type to ET_REL so that it c << 
135         # GNU ld 2.35+ and lld do not allow an << 
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t << 
137                 et_rel='\0\1'                  << 
138         else                                      117         else
139                 et_rel='\1\0'                  !! 118                 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
                                                   >> 119                         objects="-Wl,--whole-archive                    \
                                                   >> 120                                 built-in.o                              \
                                                   >> 121                                 -Wl,--no-whole-archive                  \
                                                   >> 122                                 -Wl,--start-group                       \
                                                   >> 123                                 ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 124                                 -Wl,--end-group                         \
                                                   >> 125                                 ${1}"
                                                   >> 126                 else
                                                   >> 127                         objects="${KBUILD_VMLINUX_INIT}                 \
                                                   >> 128                                 -Wl,--start-group                       \
                                                   >> 129                                 ${KBUILD_VMLINUX_MAIN}                  \
                                                   >> 130                                 ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 131                                 -Wl,--end-group                         \
                                                   >> 132                                 ${1}"
                                                   >> 133                 fi
                                                   >> 134 
                                                   >> 135                 ${CC} ${CFLAGS_vmlinux} -o ${2}                         \
                                                   >> 136                         -Wl,-T,${lds}                                   \
                                                   >> 137                         ${objects}                                      \
                                                   >> 138                         -lutil -lrt -lpthread
                                                   >> 139                 rm -f linux
140         fi                                        140         fi
141         printf "${et_rel}" | dd of="${btf_data << 
142                                                << 
143         btf_vmlinux_bin_o=${btf_data}          << 
144 }                                                 141 }
145                                                   142 
146 # Create ${2}.o file with all symbols from the !! 143 
                                                   >> 144 # Create ${2} .o file with all symbols from the ${1} object file
147 kallsyms()                                        145 kallsyms()
148 {                                                 146 {
                                                   >> 147         info KSYM ${2}
149         local kallsymopt;                         148         local kallsymopt;
150                                                   149 
151         if is_enabled CONFIG_KALLSYMS_ALL; the !! 150         if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
                                                   >> 151                 kallsymopt="${kallsymopt} --symbol-prefix=_"
                                                   >> 152         fi
                                                   >> 153 
                                                   >> 154         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
152                 kallsymopt="${kallsymopt} --al    155                 kallsymopt="${kallsymopt} --all-symbols"
153         fi                                        156         fi
154                                                   157 
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE !! 158         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
156                 kallsymopt="${kallsymopt} --ab    159                 kallsymopt="${kallsymopt} --absolute-percpu"
157         fi                                        160         fi
158                                                   161 
159         info KSYMS "${2}.S"                    !! 162         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160         scripts/kallsyms ${kallsymopt} "${1}"  !! 163                 kallsymopt="${kallsymopt} --base-relative"
161                                                !! 164         fi
162         info AS "${2}.o"                       << 
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE << 
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS << 
165                                                   165 
166         kallsymso=${2}.o                       !! 166         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
167 }                                              !! 167                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
168                                                   168 
169 # Perform kallsyms for the given temporary vml !! 169         local afile="`basename ${2} .o`.S"
170 sysmap_and_kallsyms()                          << 
171 {                                              << 
172         mksysmap "${1}" "${1}.syms"            << 
173         kallsyms "${1}.syms" "${1}.kallsyms"   << 
174                                                   170 
175         kallsyms_sysmap=${1}.syms              !! 171         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
                                                   >> 172         ${CC} ${aflags} -c -o ${2} ${afile}
176 }                                                 173 }
177                                                   174 
178 # Create map file with all symbols from ${1}      175 # Create map file with all symbols from ${1}
179 # See mksymap for additional details              176 # See mksymap for additional details
180 mksysmap()                                        177 mksysmap()
181 {                                                 178 {
182         info NM ${2}                           !! 179         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
183         ${NM} -n "${1}" | sed -f "${srctree}/s << 
184 }                                                 180 }
185                                                   181 
186 sorttable()                                    !! 182 sortextable()
187 {                                                 183 {
188         ${objtree}/scripts/sorttable ${1}      !! 184         ${objtree}/scripts/sortextable ${1}
189 }                                                 185 }
190                                                   186 
                                                   >> 187 # Delete output files in case of error
191 cleanup()                                         188 cleanup()
192 {                                                 189 {
193         rm -f .btf.*                           !! 190         rm -f .old_version
                                                   >> 191         rm -f .tmp_System.map
                                                   >> 192         rm -f .tmp_kallsyms*
                                                   >> 193         rm -f .tmp_version
                                                   >> 194         rm -f .tmp_vmlinux*
                                                   >> 195         rm -f built-in.o
194         rm -f System.map                          196         rm -f System.map
195         rm -f vmlinux                             197         rm -f vmlinux
196         rm -f vmlinux.map                      !! 198         rm -f vmlinux.o
197 }                                                 199 }
198                                                   200 
                                                   >> 201 on_exit()
                                                   >> 202 {
                                                   >> 203         if [ $? -ne 0 ]; then
                                                   >> 204                 cleanup
                                                   >> 205         fi
                                                   >> 206 }
                                                   >> 207 trap on_exit EXIT
                                                   >> 208 
                                                   >> 209 on_signals()
                                                   >> 210 {
                                                   >> 211         exit 1
                                                   >> 212 }
                                                   >> 213 trap on_signals HUP INT QUIT TERM
                                                   >> 214 
                                                   >> 215 #
                                                   >> 216 #
199 # Use "make V=1" to debug this script             217 # Use "make V=1" to debug this script
200 case "${KBUILD_VERBOSE}" in                       218 case "${KBUILD_VERBOSE}" in
201 *1*)                                              219 *1*)
202         set -x                                    220         set -x
203         ;;                                        221         ;;
204 esac                                              222 esac
205                                                   223 
206 if [ "$1" = "clean" ]; then                       224 if [ "$1" = "clean" ]; then
207         cleanup                                   225         cleanup
208         exit 0                                    226         exit 0
209 fi                                                227 fi
210                                                   228 
211 ${MAKE} -f "${srctree}/scripts/Makefile.build" !! 229 # We need access to CONFIG_ symbols
212                                                !! 230 case "${KCONFIG_CONFIG}" in
213 btf_vmlinux_bin_o=                             !! 231 */*)
214 kallsymso=                                     !! 232         . "${KCONFIG_CONFIG}"
215 strip_debug=                                   !! 233         ;;
216                                                !! 234 *)
217 if is_enabled CONFIG_KALLSYMS; then            !! 235         # Force using a file from the current directory
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy !! 236         . "./${KCONFIG_CONFIG}"
219         kallsyms .tmp_vmlinux.kallsyms0.syms . !! 237 esac
220 fi                                             << 
221                                                << 
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO << 
223                                                << 
224         # The kallsyms linking does not need d << 
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF; << 
226                 strip_debug=1                  << 
227         fi                                     << 
228                                                << 
229         vmlinux_link .tmp_vmlinux1             << 
230 fi                                             << 
231                                                << 
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then      << 
233         if ! gen_btf .tmp_vmlinux1; then       << 
234                 echo >&2 "Failed to generate B << 
235                 echo >&2 "Try to disable CONFI << 
236                 exit 1                         << 
237         fi                                     << 
238 fi                                             << 
239                                                   238 
240 if is_enabled CONFIG_KALLSYMS; then            !! 239 # Update version
                                                   >> 240 info GEN .version
                                                   >> 241 if [ ! -r .version ]; then
                                                   >> 242         rm -f .version;
                                                   >> 243         echo 1 >.version;
                                                   >> 244 else
                                                   >> 245         mv .version .old_version;
                                                   >> 246         expr 0$(cat .old_version) + 1 >.version;
                                                   >> 247 fi;
                                                   >> 248 
                                                   >> 249 # final build of init/
                                                   >> 250 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
                                                   >> 251 
                                                   >> 252 archive_builtin
                                                   >> 253 
                                                   >> 254 #link vmlinux.o
                                                   >> 255 info LD vmlinux.o
                                                   >> 256 modpost_link vmlinux.o
                                                   >> 257 
                                                   >> 258 # modpost vmlinux.o to check for section mismatches
                                                   >> 259 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
                                                   >> 260 
                                                   >> 261 kallsymso=""
                                                   >> 262 kallsyms_vmlinux=""
                                                   >> 263 if [ -n "${CONFIG_KALLSYMS}" ]; then
241                                                   264 
242         # kallsyms support                        265         # kallsyms support
243         # Generate section listing all symbols    266         # Generate section listing all symbols and add it into vmlinux
244         # It's a four step process:            !! 267         # It's a three step process:
245         # 0)  Generate a dummy __kallsyms with !! 268         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i !! 269         #     but __kallsyms is empty.
247         #     with a dummy __kallsyms.         << 
248         #     Running kallsyms on that gives u    270         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
249         #     the right size                      271         #     the right size
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i !! 272         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
251         #     the right size, but due to the a    273         #     the right size, but due to the added section, some
252         #     addresses have shifted.             274         #     addresses have shifted.
253         #     From here, we generate a correct !! 275         #     From here, we generate a correct .tmp_kallsyms2.o
254         # 3)  That link may have expanded the     276         # 3)  That link may have expanded the kernel image enough that
255         #     more linker branch stubs / tramp    277         #     more linker branch stubs / trampolines had to be added, which
256         #     introduces new names, which furt    278         #     introduces new names, which further expands kallsyms. Do another
257         #     pass if that is the case. In the    279         #     pass if that is the case. In theory it's possible this results
258         #     in even more stubs, but unlikely    280         #     in even more stubs, but unlikely.
259         #     KALLSYMS_EXTRA_PASS=1 may also u    281         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
260         #     other bugs.                         282         #     other bugs.
261         # 4)  The correct ${kallsymso} is link    283         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
262         #                                         284         #
263         # a)  Verify that the System.map from     285         # a)  Verify that the System.map from vmlinux matches the map from
264         #     ${kallsymso}.                       286         #     ${kallsymso}.
265                                                   287 
266         # The kallsyms linking does not need d !! 288         kallsymso=.tmp_kallsyms2.o
267         strip_debug=1                          !! 289         kallsyms_vmlinux=.tmp_vmlinux2
268                                                   290 
269         sysmap_and_kallsyms .tmp_vmlinux1      !! 291         # step 1
270         size1=$(${CONFIG_SHELL} "${srctree}/sc !! 292         vmlinux_link "" .tmp_vmlinux1
271                                                !! 293         kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
272         vmlinux_link .tmp_vmlinux2             !! 294 
273         sysmap_and_kallsyms .tmp_vmlinux2      !! 295         # step 2
274         size2=$(${CONFIG_SHELL} "${srctree}/sc !! 296         vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
                                                   >> 297         kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
                                                   >> 298 
                                                   >> 299         # step 3
                                                   >> 300         size1=$(stat -c "%s" .tmp_kallsyms1.o)
                                                   >> 301         size2=$(stat -c "%s" .tmp_kallsyms2.o)
275                                                   302 
276         if [ $size1 -ne $size2 ] || [ -n "${KA    303         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277                 vmlinux_link .tmp_vmlinux3     !! 304                 kallsymso=.tmp_kallsyms3.o
278                 sysmap_and_kallsyms .tmp_vmlin !! 305                 kallsyms_vmlinux=.tmp_vmlinux3
                                                   >> 306 
                                                   >> 307                 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
                                                   >> 308 
                                                   >> 309                 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
279         fi                                        310         fi
280 fi                                                311 fi
281                                                   312 
282 strip_debug=                                   !! 313 info LD vmlinux
283                                                !! 314 vmlinux_link "${kallsymso}" vmlinux
284 vmlinux_link vmlinux                           << 
285                                                   315 
286 # fill in BTF IDs                              !! 316 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab !! 317         info SORTEX vmlinux
288         info BTFIDS vmlinux                    !! 318         sortextable vmlinux
289         ${RESOLVE_BTFIDS} vmlinux              << 
290 fi                                                319 fi
291                                                   320 
                                                   >> 321 info SYSMAP System.map
292 mksysmap vmlinux System.map                       322 mksysmap vmlinux System.map
293                                                   323 
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the << 
295         info SORTTAB vmlinux                   << 
296         if ! sorttable vmlinux; then           << 
297                 echo >&2 Failed to sort kernel << 
298                 exit 1                         << 
299         fi                                     << 
300 fi                                             << 
301                                                << 
302 # step a (see comment above)                      324 # step a (see comment above)
303 if is_enabled CONFIG_KALLSYMS; then            !! 325 if [ -n "${CONFIG_KALLSYMS}" ]; then
304         if ! cmp -s System.map "${kallsyms_sys !! 326         mksysmap ${kallsyms_vmlinux} .tmp_System.map
                                                   >> 327 
                                                   >> 328         if ! cmp -s System.map .tmp_System.map; then
305                 echo >&2 Inconsistent kallsyms    329                 echo >&2 Inconsistent kallsyms data
306                 echo >&2 'Try "make KALLSYMS_E !! 330                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
307                 exit 1                            331                 exit 1
308         fi                                        332         fi
309 fi                                                333 fi
310                                                   334 
311 # For fixdep                                   !! 335 # We made a new kernel - delete old version file
312 echo "vmlinux: $0" > .vmlinux.d                !! 336 rm -f .old_version
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php